/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2016,2017          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
#ifndef _MT_COMMON_H
#define _MT_COMMON_H

/*----------------------------------------------------------*/
/*    define a structure to hold summarized info            */
/*----------------------------------------------------------*/
struct MT_summarystruct {
  int min_rank;
  int max_rank;
  int med_rank;

  void *min_result;
  void *max_result;
  void *med_result;
  void *avg_result;
  void *sum_result;

  void *all_result;
  void *sorted_all_result;
  int *sorted_rank;
  int *send_counts; /* Number of MPI point to point calls sending data to 
                       other tasks */
  long *byte_counts; /* Number of bytes sent to other tasks by MPI point to
                        point calls */
  char *hostnames; /* Array of hostnames for all application tasks */
  double synctime; /* Time task spent in synchronization for MPI collectives */
  double user_time; /* Task user CPU time */
  double system_time; /* Task system time */
  double task_max_rss; /* Max memory use (rss) for task */
  double global_max_memory; /* Global max memory utilization */
  double max_elapsed_time; /* Global max elapsed time */
  int max_memory_task; /* Task index for task with max memory utilization */
  int max_time_task; /* Task index for task with max elapsed time */
  int numtasks; /* Number of application tasks */
  int hostname_size; /* Maximum length of a hostname */
  signed char sdf_keep_data; /* Task is selected for output data generation by
                                hpcrun */
  signed char filter_by_tasklist; /* Tasks generating output specified by
                                     SAVE_LIST */
  signed char selected_for_output; /* Task is in SAVE_LIST list so should
                                      generate output */
  signed char report_task_communication; /* Report of MPI inter-task
                                            communication to be generated */
};

struct MT_envstruct {
  int mpirank;
  int xCoord;
  int yCoord;
  int zCoord;
  int xSize;
  int ySize;
  int zSize;
  int procid;
  int ntasks;
  double clockHz;
  int nmpi;
};

struct MT_tracebufferstruct {
  int number_events;
  double total_buffer;          /* in terms of MBytes */
  double used_buffer;
  double free_buffer;
};

struct MT_memorystruct {
  unsigned int max_stack_address;
  unsigned int min_stack_address;
  unsigned int max_heap_address;
};

#ifndef MT_CALLERSTRUCT
#define MT_CALLERSTRUCT
struct MT_callerstruct {
  char *filepath;
  char *filename;
  char *funcname;
  int lineno;
};
#endif

struct MT_layoutstruct {
  int *xCoord;
  int *yCoord;
  int *zCoord;
  int *procid;
};

#endif
